<?php
/*------------------------------------------------------------------------
# plg_vtemimagezoom - VTEM Image Zoom Plugin
# ------------------------------------------------------------------------
# author Nguyen Van Tuyen
# copyright Copyright (C) 2010 VTEM.NET. All Rights Reserved.
# @license - http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
# Websites: http://www.vtem.net
# Technical Support: Forum - http://vtem.net/en/forum.html
-------------------------------------------------------------------------*/
// no direct access
defined("_JEXEC") or die("Restricted Access");
jimport('legacy.response.response');
jimport('joomla.environment.response');
jimport('joomla.document.document');
jimport('joomla.plugin.helper');
jimport('joomla.plugin.plugin');
jimport('joomla.html');
jimport('joomla.application.module.helper');

class plgSystemVtemImageZoom extends JPlugin {
	function plgSystemVtemImageZoom(&$subject, $config) {
		parent::__construct($subject, $config);
		$this->mainframe = JFactory::getApplication();
	}

	public function onAfterDispatch() {
		if($this->mainframe->isAdmin()) {
			return;
		}
		$document = JFactory::getDocument();
        if ($this->params->get("script") == 1){
		$document->addScript( JURI::base(true) .'/media/plg_vtemimagezoom/assets/jquery-1.7.2.min.js');
		}
		$document->addScript( JURI::base(true) .'/media/plg_vtemimagezoom/assets/cloud-zoom.1.0.2.min.js');
		$document->addScript( JURI::base(true) .'/media/plg_vtemimagezoom/assets/jquery.elastislide.js');
		$document->addStyleSheet( JURI::base(true) .'/media/plg_vtemimagezoom/assets/style.css');
	}
	
	public function onAfterRender() {
	  $body = JResponse::getBody();
	  if(!JString::strpos($body, 'vtemzoom') || $this->mainframe->isAdmin()){
	    return;
	  }	
	  $regex = "#{vtemzoom\s*(.*?)}#s";   
	  preg_match_all($regex, $body, $matches);
 	  if (!empty($matches[0])) {
 	    $this->_build($body, $matches);
 	    return true;
	  }
		return false;
	}

	private function _build( $body, $matches ){
		for( $i = 0; $i < count($matches[0]); $i++ ){
			$tipParams = $matches[1][$i];
			$zoomer    = "";
			$zoomWidth    = $this->_params( $tipParams, "zoomWidth", $this->params->get( "zoomWidth", "auto" ));
			$zoomHeight = $this->_params( $tipParams, "zoomHeight", $this->params->get( "zoomHeight", "auto" ));
			$position    = $this->_params( $tipParams, "position", $this->params->get( "position", "right" ));
			$adjustX = $this->_params( $tipParams, "adjustX", $this->params->get( "adjustX", 0 ));
			$adjustY   = $this->_params( $tipParams, "adjustY", $this->params->get( "adjustY", 0 ));
			$softFocus   = $this->_params( $tipParams, "softFocus", $this->params->get( "softFocus", 0 ));
			$tintcolor   = $this->_params( $tipParams, "tintcolor", $this->params->get( "tintcolor", '#f60' ));
			$tintOpacity   = $this->_params( $tipParams, "tintOpacity", $this->params->get( "tintOpacity", 0.5 ));
			$lensOpacity   = $this->_params( $tipParams, "lensOpacity", $this->params->get( "lensOpacity", 0.5 ));
			$showTitle      = $this->_params( $tipParams, "showTitle", $this->params->get( "showTitle", 1 ) );
			$titleOpacity   = $this->_params( $tipParams, "titleOpacity", $this->params->get( "titleOpacity", 0.5 ));
			if($tintcolor == "none") $tintcolor = "";

			$data      = str_replace('"','\'',$this->_params( $tipParams, "image", false ));
			$title      = str_replace('"','\'',$this->_params( $tipParams, "title", false ));
			$smallwidth      = $this->_params( $tipParams, "smallwidth", 250 );
			$thumbdata      = str_replace('"','\'',$this->_params( $tipParams, "thumb", false ));
			$tinywidth      = $this->_params( $tipParams, "tinywidth", 80 );
			$scroll      = $this->_params( $tipParams, "scroll", false );
			$thumbborder      = $this->_params( $tipParams, "thumbborder", 1);
			$thumbtop      = $this->_params( $tipParams, "thumbtop", false);
			
			$images = explode(",",$data);
			$thumbs = explode(",",$thumbdata);
			if(count($images) >1){
				 if($thumbdata){$thumb = $thumbs; $smallwidth1 ='';}else{$thumb = $images; $smallwidth1='width="'.$smallwidth.'px"';}
					 if(!$thumbtop){
					 $zoomer  .= '<div class="mainzoom"><a id="vtemzoom'.(int)$i.'" class="vtemzoom cloud-zoom" href="'.trim($images[0]).'"
						rel=\'zoomWidth:"'.$zoomWidth.'", zoomHeight:"'.$zoomHeight.'", position:"'.$position.'", adjustX:'.$adjustX.', adjustY:'.$adjustY.', tint:"'.$tintcolor.'", tintOpacity:'.$tintOpacity.', lensOpacity:'.$lensOpacity.', softFocus:'.$softFocus.', showTitle:'.$showTitle.', titleOpacity:'.$titleOpacity.'\'>
						<img src="'.trim($thumb[0]).'" alt="" title="'.$title.'" '.$smallwidth1.'/></a></div>';
					 }
					 $zoomer  .= '<div id="vtemzoomthumb'.(int)$i.'" class="es-carousel-wrapper scroll0'.$scroll.'"><div class="es-carousel"><ul>';
				 foreach($images as $key => $img):
					$zoomer  .= '<li><a class="cloud-zoom-gallery" href="'.trim($img).'"
					rel=\'useZoom:"vtemzoom'.(int)$i.'", smallImage:"'.trim($thumb[$key]).'"\'>
					<img src="'.trim($thumb[$key]).'" alt="" title="'.$title.'" width="'.$tinywidth.'px"/></a></li>';
				 endforeach;
					 $zoomer  .= '</ul></div></div>';
					 if($thumbtop){
					 $zoomer  .= '<div class="mainzoom"><a id="vtemzoom'.(int)$i.'" class="vtemzoom cloud-zoom" href="'.trim($images[0]).'"
						rel=\'zoomWidth:"'.$zoomWidth.'", zoomHeight:"'.$zoomHeight.'", position:"'.$position.'", adjustX:'.$adjustX.', adjustY:'.$adjustY.', tint:"'.$tintcolor.'", tintOpacity:'.$tintOpacity.', lensOpacity:'.$lensOpacity.', softFocus:'.$softFocus.', showTitle:'.$showTitle.', titleOpacity:'.$titleOpacity.'\'>
						<img src="'.trim($thumb[0]).'" alt="" title="'.$title.'" '.$smallwidth1.'/></a></div>';
					 }
					 if($scroll){
					 $zoomer  .= '<script type="text/javascript">jQuery(document).ready(function(){jQuery("#vtemzoomthumb'. (int)$i .'").elastislide({imageW:'.$tinywidth.',border:'.$thumbborder.'})});</script>';
					 }
			}else{
			    if($thumbdata){$thumb = $thumbdata; $smallwidth1='';}else{$thumb = $data; $smallwidth1='width="'.$smallwidth.'px"';}
				$zoomer  .= '<div class="mainzoom-item" style="width:'.$smallwidth.'px"><a id="vtemzoom'. (int)$i .'" class="vtemzoom cloud-zoom" href="'.trim($data).'"
				rel=\'zoomWidth:"'.$zoomWidth.'", zoomHeight:"'.$zoomHeight.'", position:"'.$position.'", adjustX:'.$adjustX.', adjustY:'.$adjustY.', tint:"'.$tintcolor.'", tintOpacity:'.$tintOpacity.', lensOpacity:'.$lensOpacity.', softFocus:'.$softFocus.', showTitle:'.$showTitle.', titleOpacity:'.$titleOpacity.'\'>
				<img src="'.trim($thumb).'" alt="" title="'.$title.'" '.$smallwidth1.'/></a></div>';
            }
			$body = str_replace($matches[0][$i], $zoomer, $body);
		}
		JResponse::setBody($body);
	}

	private function _params( $TipParams, $param, $default = false ){
		$regex = "/". $param ."=(\s*\[.*?\])/s";
		preg_match_all( $regex, $TipParams, $options );
		$value = !empty($options[1][0]) ? JString::trim( $options[1][0], '[]' ) : trim($default);
		return $value;
	}
}
?>